SystemOrganization addCategory: #TrialAndError!

Morph subclass: #TAEDragNDropEditor
	instanceVariableNames: 'menuBar field'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAEDragNDropEditor class methodsFor: 'example' stamp: 'CW 1/25/2017 08:17'!
example

	self new openInWorld ! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 13:56'!
buildField

	self field: TAEDragNDropField new.
	self field extent: 500@500.
	self addMorph: self field.! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 15:53'!
buildLoadButton

	^(SimpleButtonMorph newWithLabel: 'Load')
		target: self;
		actionSelector: #loadField;
		yourself ! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 17:38'!
buildMenuBar
	
	self menuBar: Morph new.
	self menuBar 
		position: self field topRight;
		height: self field height;
		width: self menuBarItemSize x * 3;
		color: Color yellow.
			
	self buildMenuBarItems.
	self addMorph: self menuBar.! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 17:47'!
buildMenuBarItems
		
	|numItems|
	
	numItems := self field height / (self menuBarItemSize y * 2).
	(1 to: numItems-2)  do: [:slotIndex| |color newItem|
		color:= self itemColors at: slotIndex ifAbsent: [Color green].
		newItem := TAEDragNDropItem new color: color.
		self centerItem: newItem inPosition: slotIndex].
	
	self centerItem: self buildLoadButton inPosition: numItems - 1.
	self centerItem: self buildSaveButton inPosition: numItems.! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 15:54'!
buildSaveButton

	^(SimpleButtonMorph newWithLabel: 'Save')
		target: self;
		actionSelector: #saveField;
		yourself! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 14:43'!
centerItem: aMorph inPosition: aNumber

	self menuBar addMorph: aMorph.
	aMorph 
		extent: self menuBarItemSize;
		x: self menuBar center x;
		y: aNumber-1 * (self menuBarItemSize y * 2) + self menuBar top + (self menuBarItemSize y/2).
	! !

!TAEDragNDropEditor methodsFor: 'accessing' stamp: 'CW 1/19/2017 08:21'!
field

	^ field! !

!TAEDragNDropEditor methodsFor: 'accessing' stamp: 'CW 1/19/2017 08:21'!
field: anObject

	field := anObject! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 14:00'!
initialize 

	super initialize.
	
	self buildField.
	self buildMenuBar.
	
	self width: self field width + self menuBar width.
	self height: self field height! !

!TAEDragNDropEditor methodsFor: 'initialization' stamp: 'CW 1/23/2017 17:44'!
itemColors

	"look up 'once' in BlockClosure to see what happens here. and ask you why!!"
	^[{Color green. Color brown. Color magenta. Color orange. Color gray}] once! !

!TAEDragNDropEditor methodsFor: 'fileIn/out' stamp: 'CW 1/23/2017 15:51'!
loadField
	
	|rr newField|
	
	rr := ReferenceStream fileNamed: 'TAEField.obj'.
	newField := rr next.
	rr close.
	self replaceFieldWith: newField.! !

!TAEDragNDropEditor methodsFor: 'accessing' stamp: 'CW 1/19/2017 08:21'!
menuBar

	^ menuBar! !

!TAEDragNDropEditor methodsFor: 'accessing' stamp: 'CW 1/19/2017 08:21'!
menuBar: anObject

	menuBar := anObject! !

!TAEDragNDropEditor methodsFor: 'constant' stamp: 'CW 1/20/2017 16:41'!
menuBarItemSize

	^50@50! !

!TAEDragNDropEditor methodsFor: 'fileIn/out' stamp: 'CW 1/23/2017 17:37'!
replaceFieldWith: aMorph
		
	aMorph
		position: self field position;
		extent: self field extent.
	self field delete.
	self field: aMorph.
	self addMorph: aMorph! !

!TAEDragNDropEditor methodsFor: 'fileIn/out' stamp: 'CW 1/23/2017 14:59'!
saveField

	| rr |
	
	rr := ReferenceStream fileNamed: 'TAEField.obj'.
	rr nextPut: self field.
	rr close! !

Morph subclass: #TAEDragNDropField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAEDragNDropField methodsFor: 'dropping/grabbing' stamp: 'CW 1/23/2017 13:57'!
wantsDroppedMorph: aMorph event: evt 

	^aMorph isKindOf: TAEDragNDropItem ! !

Morph subclass: #TAEDragNDropItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAEDragNDropItem methodsFor: 'event handling' stamp: 'CW 1/20/2017 16:31'!
handlesMouseDown: evt

 	^true
	
	! !

!TAEDragNDropItem methodsFor: 'event handling' stamp: 'CW 1/23/2017 17:52'!
mouseDown: evt 

	(self owner isKindOf: TAEDragNDropField)
		ifTrue: [self delete]
		ifFalse: [evt hand grabMorph: self copy]
	
	! !

!TAEDragNDropItem methodsFor: 'dropping/grabbing' stamp: 'CW 1/23/2017 13:57'!
wantsToBeDroppedInto: aMorph

	^aMorph isKindOf: TAEDragNDropField ! !

Morph subclass: #TAEGame
	instanceVariableNames: 'obstacles character directions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAEGame class methodsFor: 'example' stamp: 'CW 1/25/2017 08:17'!
example 

	^self new openInWorld! !

!TAEGame methodsFor: 'accessing' stamp: 'CW 12/14/2016 13:44'!
character

	^ character! !

!TAEGame methodsFor: 'accessing' stamp: 'CW 12/14/2016 13:44'!
character: anObject

	character := anObject! !

!TAEGame methodsFor: 'event handling' stamp: 'CW 1/10/2017 13:15'!
directions
	
	"lazy initialize directions. note that directions has no setter"
	^directions ifNil: [
		directions :=Dictionary newFrom: {
			$W -> (0@ -1).
			$A -> (-1@0).
			$S -> (0@1).
			$D -> (1@0)}]
! !

!TAEGame methodsFor: 'event handling' stamp: 'CW 1/4/2017 17:07'!
handlesKeyboard: anEvent

	"we want key events!!"
	^true! !

!TAEGame methodsFor: 'initialization' stamp: 'CW 1/9/2017 19:08'!
initialize 

	"compose method idiom. also always call super in initialize"
	super initialize.
	
	self 
		initializePlayfield;
		initializeCharacter! !

!TAEGame methodsFor: 'initialization' stamp: 'CW 1/20/2017 09:31'!
initializeCharacter
		
	"create a Character, register it in the game, and configure its properties"
	self 
		character: TAEGameCharacter new;
		addMorph: self character.
		
	self character 
		color: Color green;
		bottom: self bottom.
! !

!TAEGame methodsFor: 'initialization' stamp: 'CW 1/4/2017 17:14'!
initializePlayfield 
	
	"shape myself into a beautifully designed area"
	self 
		extent: 700@600; 
		obstacles: OrderedCollection new;
		placeObstacles.
! !

!TAEGame methodsFor: 'event handling' stamp: 'CW 1/4/2017 17:09'!
keyDown: anEvent
	
	"move directions has an entry for the pressed key"
	self directions at: anEvent keyCharacter ifPresent: [:direction|
		self character move: direction].! !

!TAEGame methodsFor: 'accessing' stamp: 'CW 12/14/2016 13:44'!
obstacles

	^ obstacles! !

!TAEGame methodsFor: 'accessing' stamp: 'CW 12/14/2016 13:44'!
obstacles: anObject

	obstacles := anObject! !

!TAEGame methodsFor: 'initialization' stamp: 'CW 1/4/2017 17:16'!
placeObstacles

	"create some obstacles"
	(1 to: 6) do: [:i | |newObstacle|
		newObstacle := Morph new
			color: Color red;
			position: self position + 75 * i.
		self obstacles add: newObstacle.
		self addMorph: newObstacle]! !

Morph subclass: #TAEGameCharacter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAEGameCharacter methodsFor: 'movement' stamp: 'CW 1/4/2017 17:16'!
canMoveTo: aRect 

	"i can't leave my owner and must respect all its obstacles"
	^ (self owner bounds containsRect: aRect) and: [
		self owner obstacles noneSatisfy: [:anObstacle | 
			anObstacle bounds intersects: aRect]]! !

!TAEGameCharacter methodsFor: 'movement' stamp: 'CW 1/9/2017 19:17'!
move: direction

	"look ahead where one step would take me. if so, go for it!!"
	|newBounds|
	
	newBounds := direction * self moveWidth + self position extent: self extent.
	(self canMoveTo: newBounds) ifTrue: [
		self bounds: newBounds]
! !

!TAEGameCharacter methodsFor: 'movement' stamp: 'CW 1/4/2017 17:21'!
moveWidth

	"one step reaches half my width"
	^ self bounds width / 2
! !

Morph subclass: #TAESideScroller
	instanceVariableNames: 'obstacles character stepNum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAESideScroller class methodsFor: 'example' stamp: 'CW 1/27/2017 13:27'!
example

	^self new openInWorld! !

!TAESideScroller methodsFor: 'accessing' stamp: 'CW 1/27/2017 12:53'!
character

	^ character! !

!TAESideScroller methodsFor: 'accessing' stamp: 'CW 1/27/2017 12:53'!
character: anObject

	character := anObject! !

!TAESideScroller methodsFor: 'scroll' stamp: 'CW 1/27/2017 13:17'!
deleteObstacle: aMorph

	self removeMorph: aMorph.
	self obstacles remove: aMorph

	
	
	
	
	
	
	
	! !

!TAESideScroller methodsFor: 'stepping and presenter' stamp: 'CW 1/27/2017 13:00'!
incrementStepNum

	self stepNum: self stepNum + 1 \\ 100.! !

!TAESideScroller methodsFor: 'initialization' stamp: 'CW 1/27/2017 13:07'!
initialize

	super initialize.
	
	self 
		extent: 1000@400;
		clipSubmorphs: true;
		stepNum: 0;
		obstacles: OrderedCollection new;
		character: TAESideScrollerCharacter new;
		addMorph: self character
	
	
	
	
	
	
	! !

!TAESideScroller methodsFor: 'scroll' stamp: 'CW 1/27/2017 13:18'!
isOutOfSight: aMorph

	^(aMorph bounds intersects: self bounds) not

	
	
	
	
	
	
	
	! !

!TAESideScroller methodsFor: 'scroll' stamp: 'CW 1/27/2017 13:12'!
lose
	
	self stopStepping.
	self character stopStepping.
	self color: Color yellow	! !

!TAESideScroller methodsFor: 'scroll' stamp: 'CW 1/27/2017 13:21'!
moveAllObstacles
	
	self obstacles do: [ :each |
		self moveObstacle: each].	! !

!TAESideScroller methodsFor: 'scroll' stamp: 'CW 1/27/2017 13:31'!
moveObstacle: aMorph

	aMorph position: aMorph position - (self obstacleSpeed@0).
	
	(self isOutOfSight: aMorph) 
		ifTrue: [self deleteObstacle: aMorph].
		
	(self playerIsHitBy: aMorph) 
		ifTrue: [self lose]	! !

!TAESideScroller methodsFor: 'scroll' stamp: 'CW 1/27/2017 13:14'!
obstacleSpeed

	^5! !

!TAESideScroller methodsFor: 'accessing' stamp: 'CW 1/27/2017 12:53'!
obstacles

	^ obstacles! !

!TAESideScroller methodsFor: 'accessing' stamp: 'CW 1/27/2017 12:53'!
obstacles: anObject

	obstacles := anObject! !

!TAESideScroller methodsFor: 'scroll' stamp: 'CW 1/27/2017 13:11'!
playerIsHitBy: aMorph
	
	^aMorph bounds intersects: self character bounds! !

!TAESideScroller methodsFor: 'stepping and presenter' stamp: 'CW 1/27/2017 13:00'!
shouldSpawnObstacleInCurrentStep

	^self stepNum = 1! !

!TAESideScroller methodsFor: 'stepping and presenter' stamp: 'CW 1/27/2017 13:32'!
spawnObstacle

	| newObstacle |
	
	newObstacle := Morph new.
	newObstacle
		color: Color black;
		bottomLeft: self bottomRight.
	self obstacles add: newObstacle.
	self addMorph: newObstacle

	
	
	
	
	
	
	
	! !

!TAESideScroller methodsFor: 'stepping and presenter' stamp: 'CW 1/27/2017 13:31'!
step

	self incrementStepNum.
	self shouldSpawnObstacleInCurrentStep 
		ifTrue: [self spawnObstacle].
	self moveAllObstacles.! !

!TAESideScroller methodsFor: 'accessing' stamp: 'CW 1/27/2017 12:53'!
stepNum

	^ stepNum! !

!TAESideScroller methodsFor: 'accessing' stamp: 'CW 1/27/2017 12:53'!
stepNum: anObject

	stepNum := anObject! !

!TAESideScroller methodsFor: 'stepping and presenter' stamp: 'CW 11/15/2016 18:59'!
stepTime 

	^ 10! !

Morph subclass: #TAESideScrollerCharacter
	instanceVariableNames: 'velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAESideScrollerCharacter methodsFor: 'jumping' stamp: 'CW 1/27/2017 12:48'!
applyGravity

	self velocity: self velocity - self gravity 

	
				! !

!TAESideScrollerCharacter methodsFor: 'jumping' stamp: 'CW 1/27/2017 13:33'!
applyVelocity

	self position: self position - (0@self velocity)

	
				! !

!TAESideScrollerCharacter methodsFor: 'jumping' stamp: 'CW 1/27/2017 12:48'!
gravity

	^1! !

!TAESideScrollerCharacter methodsFor: 'event handling' stamp: 'CW 11/15/2016 19:20'!
handlesKeyboard: evt

	^true! !

!TAESideScrollerCharacter methodsFor: 'event handling' stamp: 'CW 1/9/2017 19:12'!
indicateKeyboardFocus 

	^false! !

!TAESideScrollerCharacter methodsFor: 'initialization' stamp: 'CW 1/27/2017 09:48'!
initialize

	super initialize.
	
	self 
		velocity: 0;
		color: Color red;
		grabKeyboard.! !

!TAESideScrollerCharacter methodsFor: 'jumping' stamp: 'CW 1/27/2017 12:46'!
jump

	self velocity: self jumpEnergy! !

!TAESideScrollerCharacter methodsFor: 'jumping' stamp: 'CW 1/27/2017 09:48'!
jumpEnergy

	^20! !

!TAESideScrollerCharacter methodsFor: 'event handling' stamp: 'CW 1/27/2017 12:48'!
keyStroke: anEvent

	self reachedTheGround ifTrue: [self jump]
! !

!TAESideScrollerCharacter methodsFor: 'jumping' stamp: 'CW 1/27/2017 09:49'!
reachedTheGround
	
	^self velocity < 1 and: [self bottom >= self owner bottom]
				! !

!TAESideScrollerCharacter methodsFor: 'jumping' stamp: 'CW 1/27/2017 12:44'!
standOnGround
				
	self bottom: self owner bottom;
		velocity: 0.! !

!TAESideScrollerCharacter methodsFor: 'stepping and presenter' stamp: 'CW 1/27/2017 12:45'!
step
	
	self reachedTheGround 
		ifTrue: [^self standOnGround].

	self applyVelocity;
		applyGravity 
				! !

!TAESideScrollerCharacter methodsFor: 'stepping and presenter' stamp: 'CW 1/27/2017 09:32'!
stepTime 

	^10! !

!TAESideScrollerCharacter methodsFor: 'accessing' stamp: 'CW 1/27/2017 09:47'!
velocity

	^ velocity! !

!TAESideScrollerCharacter methodsFor: 'accessing' stamp: 'CW 1/27/2017 09:47'!
velocity: anObject

	velocity := anObject! !

!TAESideScrollerCharacter methodsFor: 'event handling' stamp: 'CW 1/9/2017 19:12'!
wantsKeyboardFocus 

	^true! !

Morph subclass: #TAESlidingBackground
	instanceVariableNames: 'imageMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAESlidingBackground class methodsFor: 'example' stamp: 'CW 1/25/2017 16:09'!
example 
	
	| mainMorph background|
	
	mainMorph := Morph new openInWorld extent: 300@100.
	background := self new.
	background asBackgroundOf: mainMorph with: ImageMorph new.! !

!TAESlidingBackground methodsFor: 'setup' stamp: 'CW 1/26/2017 08:47'!
asBackgroundOf: aMorph with: imageMorph 

	self imageMorph: imageMorph;
		position: aMorph position;
		extent: aMorph extent;
		clipSubmorphs: true.
	aMorph addMorph: self.

	
	(self extent x / imageMorph extent x) ceiling 
		timesRepeat: [self createNextImage]
 
	! !

!TAESlidingBackground methodsFor: 'helper' stamp: 'CW 1/26/2017 08:39'!
createNextImage

	| newImage |
	newImage := self imageMorph copy.
	newImage position: self nextEmptyPosition.
	self addMorphBack: newImage
	
	! !

!TAESlidingBackground methodsFor: 'accessing' stamp: 'CW 1/25/2017 08:25'!
imageMorph

	^ imageMorph! !

!TAESlidingBackground methodsFor: 'accessing' stamp: 'CW 1/25/2017 08:25'!
imageMorph: anObject

	imageMorph := anObject! !

!TAESlidingBackground methodsFor: 'helper' stamp: 'CW 1/26/2017 08:24'!
leftMostImage
		
	^self submorphs first
	
	! !

!TAESlidingBackground methodsFor: 'helper' stamp: 'CW 1/26/2017 08:38'!
nextEmptyPosition

	self submorphs ifEmpty: [^self position].
	^self rightMostImage topRight.
	
	! !

!TAESlidingBackground methodsFor: 'helper' stamp: 'CW 1/26/2017 08:25'!
rightMostImage
		
	^self submorphs last
	
	! !

!TAESlidingBackground methodsFor: 'stepping and speed' stamp: 'CW 1/26/2017 08:54'!
scroll

	self submorphs do: [:elem|
		elem x: elem x - self scrollWidth].
	
	self leftMostImage right < self left 
		ifTrue: [self leftMostImage delete].
	
	self rightMostImage right < self right
		ifTrue: [self createNextImage]
	
	! !

!TAESlidingBackground methodsFor: 'stepping and speed' stamp: 'CW 1/26/2017 14:01'!
scrollWidth

	^10! !

!TAESlidingBackground methodsFor: 'stepping and speed' stamp: 'CW 1/26/2017 08:38'!
step

	self submorphs ifNotEmpty: [self scroll]
	
	! !

!TAESlidingBackground methodsFor: 'stepping and speed' stamp: 'CW 1/26/2017 14:01'!
stepTime

	^100
	
	! !

StringMorph subclass: #TAEMouseDistanceIndicator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAEMouseDistanceIndicator class methodsFor: 'example' stamp: 'CW 1/24/2017 17:18'!
example 

	self new
		position: World center;
		color: Color red; 
		openInWorld.
	! !

!TAEMouseDistanceIndicator methodsFor: 'stepping and presenter' stamp: 'CW 1/24/2017 17:16'!
step

	|distance|
	
	distance := self position - World activeHand center.
	self contents: (distance x squared + distance y squared) sqrt rounded asString! !

TransformationMorph subclass: #TAERotatingImage
	instanceVariableNames: 'currentAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TrialAndError'!

!TAERotatingImage class methodsFor: 'example' stamp: 'CW 1/24/2017 17:23'!
example

	|instance| 
	
	instance := self new
		position: World center;
		openInWorld.
		
	instance futureDo: #delete at: 3000 args: {}	
	! !

!TAERotatingImage methodsFor: 'accessing' stamp: 'CW 1/3/2017 18:27'!
currentAngle
	^ currentAngle! !

!TAERotatingImage methodsFor: 'accessing' stamp: 'CW 1/3/2017 18:27'!
currentAngle: anObject
	currentAngle := anObject! !

!TAERotatingImage methodsFor: 'initialization' stamp: 'CW 1/3/2017 18:28'!
initialize 
	
	super initialize.

	self 
		asFlexOf: ImageMorph new;
		currentAngle: 0.! !

!TAERotatingImage methodsFor: 'stepping and presenter' stamp: 'CW 1/3/2017 18:29'!
step

	"perform one rotation per second"
	self 
		currentAngle: self currentAngle + (360*self stepTime / 1000) \\ 360;
		rotationDegrees: self currentAngle.! !

!TAERotatingImage methodsFor: 'stepping and presenter' stamp: 'CW 1/10/2017 10:31'!
stepTime 

	"100 times a second ie. every 10 ms"
	^10! !
